package com.kakao.sdk.auth

import com.kakao.sdk.auth.model.AccessTokenResponse
import com.kakao.sdk.auth.model.AgtResponse
import com.kakao.sdk.common.KakaoSdk
import retrofit2.Call
import retrofit2.http.Field
import retrofit2.http.FormUrlEncoded
import retrofit2.http.POST

interface AuthApi {
    @POST(Constants.TOKEN_PATH)
    @FormUrlEncoded
    fun issueAccessToken(
        @Field(Constants.CLIENT_ID) clientId: String = KakaoSdk.applicationContextInfo.appKey,
        @Field(Constants.REDIRECT_URI) redirectUri: String?,
        @Field(Constants.ANDROID_KEY_HASH) androidKeyHash: String,
        @Field(Constants.CODE) authCode: String? = null,
        @Field(Constants.REFRESH_TOKEN) refreshToken: String? = null,
        @Field(Constants.GRANT_TYPE) grantType: String = Constants.AUTHORIZATION_CODE
    ): Call<AccessTokenResponse>

    @POST(Constants.AGT_PATH)
    @FormUrlEncoded
    fun agt(
        @Field(Constants.CLIENT_ID) clientId: String = KakaoSdk.applicationContextInfo.appKey,
        @Field(Constants.ACCESS_TOKEN) accessToken: String
    ): Call<AgtResponse>
}