//package com.kakao.sdk.auth
//
//import android.util.Log
//import com.kakao.sdk.common.Constants
//import com.kakao.sdk.common.KakaoJson
//import com.kakao.sdk.common.model.ApiErrorResponse
//import com.kakao.sdk.common.model.ClientError
//import com.kakao.sdk.common.model.ClientErrorCause
//import okhttp3.Interceptor
//import okhttp3.Response
//import java.util.concurrent.CountDownLatch
//
//class RefreshTokenInterceptor(
//    val authApiClient: AuthApiClient = AuthApiClient.instance,
//    val tokenRepo: AccessTokenRepo = AccessTokenRepo.instance
//): Interceptor {
//    override fun intercept(chain: Interceptor.Chain): Response {
//        val originalRequest = chain.request()
//        val response = chain.proceed(originalRequest)
//        Log.e("original response", response.peekBody(500)?.string())
//
//        if (response.code() < 400) {
//            return response
//        }
//
//        val errorString = response.peekBody(500)?.string()
//        val apiError = KakaoJson.fromJson<ApiErrorResponse>(
//            errorString!!,
//            ApiErrorResponse::class.java
//        )
//
//        val refreshToken = tokenRepo.getToken().refreshToken
//
//        if (apiError.code == -401 && refreshToken != null) {
//            Log.e("******** RETRY", "Invalid token should refresh")
//            val latch = CountDownLatch(1)
//            authApiClient.refreshAccessToken(refreshToken) { response, throwable ->
//                latch.countDown()
//            }
//            latch.await()
//            val token = tokenRepo.getToken().accessToken
//                ?: throw ClientError(ClientErrorCause.TokenNotFound, "")
//            Log.e("******** RETRY", token)
//            val newRequest = originalRequest.newBuilder()
//                .header(Constants.AUTHORIZATION, "${Constants.BEARER} $token")
//                .build()
//            Log.e("******** RETRY", newRequest.toString())
//            return chain.proceed(newRequest)
//        }
//
//        return response
//
//    }
//}
